/****************************************************************************
 IRC Script Add-on Program. For use with any UNIX Operating System
 Copyright (C) pent (pent@wh314c.admin.rpi.edu)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 Filename    : COLORS.C
 Description : bitZ Color Configuration program
 Author      : pent (pent@blackmoon.net)
 Contributors: psionic (psionic@blackmoon.net)
*****************************************************************************/
/* To compile : gcc -o color color.c OR cc -o color color.c */ 
#include <stdio.h>

char *fg(char blah[3]) {
        blah[0]=toupper(blah[0]);
        blah[1]=toupper(blah[1]); 
        blah[2]=toupper(blah[2]);
	if(strstr(blah,"BLA")) return("${BLK}"); 
	else
	if(strstr(blah,"BLU")) return("${BLU}"); 
	else
	if(strstr(blah,"GRE")) return("${GRN}"); 
	else
	if(strstr(blah,"RED")) return("${RED}"); 
	else
	if(strstr(blah,"MAG")) return("${MAG}"); 
	else
	if(strstr(blah,"CYA")) return("${CYN}"); 
	else
	if(strstr(blah,"WHI")) return("${WHT}"); 
	else
	if(strstr(blah,"YEL")) return("${YEL}"); 
	else
	if(strstr(blah,"HBC")) return("${HBLK}");
	else
	if(strstr(blah,"HBL")) return("${HBLU}"); 
	else
	if(strstr(blah,"HGR")) return("${HGRN}"); 
	else
	if(strstr(blah,"HRE")) return("${HRED}"); 
	else
	if(strstr(blah,"HMA")) return("${HMAG}"); 
	else
	if(strstr(blah,"HCY")) return("${HCYN}"); 
	else
	if(!strcmp(blah,"HWH")) return("${HWHT}"); 
	else
	if(strstr(blah,"HYE")) return("${HYEL}"); 
	else return("${WHT}");
}
char *bg(char blah[3]) {
	if(strstr(blah,"BLA")) return("${BLK_B}");
	else
	if(strstr(blah,"BLU")) return("${BLU_B}");
	else
	if(strstr(blah,"GRE")) return("${GRN_B}");
	else
	if(strstr(blah,"RED")) return("${RED_B}");
	else
	if(strstr(blah,"MAG")) return("${MAG_B}");
	else
	if(strstr(blah,"CYA")) return("${CYN_B}");
	else
	if(strstr(blah,"WHI")) return("${WHT_B}");
	else	
	if(strstr(blah,"YEL")) return("${YEL_B}");
	else return("${BLK_B}");
}
                                                             

void wf(FILE *bitz,char var[8],char val[8]) {
	fprintf(bitz,"@ %s = [%s]\n",var,val);
}

main() {
	FILE *bz;
	struct {
		char msg[8],msgbrac[8],msguh[8],smsg[8],notice[8],dcc[8],wis[8],winfo[8];
		char ctcp[8],ctcpban[8],ctcpnk[8],mode[8],modenk[8],peren[8],reply[8],pub[8];
		char pubbrac[8],lowlvl[8],hilvl[8],spub[8],join[8],joinuh[8],sign[8],topic[8];
		char topicchan[8],section[8],invitech[8],invitenk[8],kill[8],killnk[8],notify[8];
		char hilite[8],split[8],errtopic[8],error[8],time[8],action[8],sendout[8];
		char fctcp[8],kicked[8],kickn[8],kickc[8],email[8],nick[8];
                char smsgbrac[8];
	} fc;
	struct {
		char msg[8],smsg[8],notice[8],dcc[8];
	} bc;

	bz=fopen("bcolors","w+");
	printf("Just enter the first three leters of the color at the prompt...\n");
	printf("The intense colors are prefixed with an H <ie HBL HRE>\n");
	printf("[1;37mIntense black is 'HBCK (HBC)'[0m\n");
	printf("foreground choices are: red,blue,green,yellow,black,magenta,\n");
	printf("cyan -- and their intense counterparts.  background colors are\n");
	printf("the same, but there are no intense background colors.\n\n");
	printf("Enter color for received message foreground ->");
	scanf("%s",fc.msg);
	wf(bz,"fc.msg",fg(fc.msg));
	printf("Enter color for received message background ->");
	scanf("%s",bc.msg);
	wf(bz,"bc.msg",bg(bc.msg));
	printf("Enter color for brackets in received message ->");
	scanf("%s",fc.msgbrac);
	wf(bz,"fc.msgbrac",fg(fc.msgbrac));
	printf("Enter color for userhost in received message ->");
	scanf("%s",fc.msguh);
	wf(bz,"fc.msguh",fg(fc.msguh));
	printf("Enter color for sent message foreground ->");
	scanf("%s",fc.smsg);
	wf(bz,"fc.smsg",fg(fc.smsg));
        printf("Enter color for brackets around sent message ->");
        scanf("%s",fc.smsgbrac);
        wf(bz,"fc.smsgbrac",fg(fc.smsgbrac));
       	printf("Enter color for sent message background ->");
	scanf("%s",bc.smsg);
	wf(bz,"bc.smsg",bg(bc.smsg));
	printf("Enter color for received notice foreground ->");
	scanf("%s",fc.notice);
	wf(bz,"fc.notice",fg(fc.notice));
	printf("Enter color for received notice background ->");
	scanf("%s",bc.notice);
	wf(bz,"bc.notice",bg(bc.notice));
	printf("Enter color for received dcc chat foreground ->");
	scanf("%s",fc.dcc);
	wf(bz,"fc.dcc",fg(fc.dcc));
	printf("Enter color for received dcc chat background ->");
	scanf("%s",bc.dcc);
	wf(bz,"bc.dcc",bg(bc.dcc));
	printf("Enter color for whois labels ->");
	scanf("%s",fc.wis);
	wf(bz,"fc.wis",fg(fc.wis));
	printf("Enter color for whois information ->");
	scanf("%s",fc.winfo);
	wf(bz,"fc.winfo",fg(fc.winfo));
	printf("Enter color for ctcp type ->");
	scanf("%s",fc.ctcp);
	wf(bz,"fc.ctcp",fg(fc.ctcp));
	printf("Enter color for ctcp banner ->");
	scanf("%s",fc.ctcpban);
	wf(bz,"fc.ctcpban",fg(fc.ctcpban)); 
	printf("Enter color for ctcp nick ->");
	scanf("%s",fc.ctcpnk);
	wf(bz,"fc.ctcpnk",fg(fc.ctcpnk));
	printf("Enter color for mode change/mode channel ->");
	scanf("%s",fc.mode);
	wf(bz,"fc.mode",fg(fc.mode));
	printf("Enter color for nick of mode changer ->");
	scanf("%s",fc.modenk);
	wf(bz,"fc.modenk",fg(fc.modenk));
	printf("Enter color for perentheses ->");
	scanf("%s",fc.peren);
	wf(bz,"fc.peren",fg(fc.peren));
	printf("Enter color for auto-reply ->");
	scanf("%s",fc.reply);
	wf(bz,"fc.reply",fg(fc.reply));
	printf("Enter color for people's nicks in public ->");
	scanf("%s",fc.pub);
	wf(bz,"fc.pub",fg(fc.pub));
	printf("Enter color for brackets around public talking ->");
	scanf("%s",fc.pubbrac);
	wf(bz,"fc.pubbrac",fg(fc.pubbrac));
	printf("Enter color for highlight of low level friends in public ->");
	scanf("%s",fc.lowlvl);
	wf(bz,"fc.lowlvl",fg(fc.lowlvl));
	printf("Enter color for highlight of high level friends in public ->");
	scanf("%s",fc.hilvl);
	wf(bz,"fc.hilvl",fg(fc.hilvl));
	printf("Enter color for your nick in sent public messages ->");
	scanf("%s",fc.spub);
	wf(bz,"fc.spub",fg(fc.spub));
	printf("Enter color of nick/channel on join ->");
	scanf("%s",fc.join);
	wf(bz,"fc.join",fg(fc.join));
	printf("Enter color of someone's host on join ->");
	scanf("%s",fc.joinuh);
	wf(bz,"fc.joinuh",fg(fc.joinuh));
	printf("Enter color of nick/channel on signoff ->");
	scanf("%s",fc.sign);
	wf(bz,"fc.sign",fg(fc.sign));
	printf("Enter color of nick on topic change ->");
	scanf("%s",fc.topic);
	wf(bz,"fc.topic",fg(fc.topic));
	printf("Enter color of channel on topic change ->");
	scanf("%s",fc.topicchan);
	wf(bz,"fc.topicchan",fg(fc.topicchan));
	printf("Enter color of section banner in /sc ->");
	scanf("%s",fc.section);
	wf(bz,"fc.section",fg(fc.section));
	printf("Enter color of channel on invite ->");
	scanf("%s",fc.invitech);
	wf(bz,"fc.invitech",fg(fc.invitech));
	printf("Enter color of nick on invite ->");
	scanf("%s",fc.invitenk);
	wf(bz,"fc.invitenk",fg(fc.invitenk));
	printf("Enter color of operator /kill message ->");
	scanf("%s",fc.kill);
	wf(bz,"fc.kill",fg(fc.kill));
	printf("Enter color of nick who was /killed ->");
	scanf("%s",fc.killnk);
	wf(bz,"fc.killnk",fg(fc.killnk));
	printf("Enter color of notify banner ->");
	scanf("%s",fc.notify);
	wf(bz,"fc.notify",fg(fc.notify));
	printf("Enter color of hilite for all stats ->");
	scanf("%s",fc.hilite);
	wf(bz,"fc.hilite",fg(fc.hilite));
	printf("Enter color of split servers ->");
	scanf("%s",fc.split);
	wf(bz,"fc.split",fg(fc.split));
	printf("Enter color of nick/channel that is involved in an error ->");
	scanf("%s",fc.errtopic);
	wf(bz,"fc.errtopic",fg(fc.errtopic));
	printf("Enter color of error messages ->");
	scanf("%s",fc.error);
	wf(bz,"fc.error",fg(fc.error));
	printf("Enter color of usage time when you signoff ->");
	scanf("%s",fc.time);
	wf(bz,"fc.time",fg(fc.time));
	printf("Enter color of nicks involved in an action (/me) ->");
	scanf("%s",fc.action);
	wf(bz,"fc.action",fg(fc.action));
	printf("Enter color of banner before outgoing messages/notices ->");
	scanf("%s",fc.sendout);
	wf(bz,"fc.sendout",fg(fc.sendout));
	printf("Enter color of fake ctcp string ->");
	scanf("%s",fc.fctcp);
	wf(bz,"fc.fctcp",fg(fc.fctcp));
        printf("Enter color of nicks on nick change ->");
        scanf("%s",fc.nick);
        wf(bz,"fc.nick",fg(fc.nick));
      	printf("Enter color of nicks who are kicked ->");
	scanf("%s",fc.kicked);
	wf(bz,"fc.kicked",fg(fc.kicked));
	printf("Enter color of the person who does the kicking ->");
	scanf("%s",fc.kickn);
	wf(bz,"fc.kickn",fg(fc.kickn));
	printf("Enter color of channel where kicking takes place ->");
	scanf("%s",fc.kickc);
	wf(bz,"fc.kickc",fg(fc.kickc));
	printf("Enter color of new email message ->");
	scanf("%s",fc.email);
	wf(bz,"fc.email",fg(fc.email));
	printf("\nCongratulations, you have just completed the bitZ color configuration!\n");
	printf("We have written the file bcolors.  Look it over, and when you are\n");
	printf("satisfied with it, move it to ~/.bcolors to be loaded automatically\n");
	printf("at script start-up...  Enjoy [1;37mbitZ![0m\n");

	fclose(bz);
}

